// Javascript code to support the debugger tool in the enCore Program editor;
// KRJ June 9, 2011;
// This code will extract all the variables from the moo-code in the editor textarea;
// A form with a checkbox for each variable will be used to generate debug checkpoints for insertion into the code; 
// To insert the checkpoints make sure the cursor is sitting where you want the breakpoint to go;
function getText() {
      var varList= new Array();
	  // set foundArgs to false if you want to check for the argument assignment;
	  var foundArgs=true;
	  var tmpString=String();
	  var stuff=parent.frames["editor"].document.getElementById('verb_code').value;
	  var allLines = stuff.split("\n") //split using LF;
      //alert("code has "+ allLines.length +" lines.");
	  for (var i=0; i<allLines.length; i++) {
	       if(!foundArgs) {
		    // check if we are looking at the argument assignment line, if so skip it;
			tmpString=allLines[i];  
            if (tmpString.match("args;")){
              foundArgs=true;
			  i++;
              alert("Found argument assignment");
			  }
             }	 
          var variableFound=findVar(allLines[i]);
          if (variableFound){
		       varList=varList.concat(variableFound);
          }
	   // sort the list;  
       varList=varList.sort();
	   // remove duplicate variable entries;
	   for(var v = 1; v < varList.length; ){
            if(varList[v-1] == varList[v]){
                varList.splice(v, 1);
            } else {
                v++;
            }
        }
       }
	  //create a list of checkboxes with the variable names as value, name and id;
       var chkboxCreated=createChkboxList(varList);
	   if (chkboxCreated) {
	   return true;
	   }
       else {
	   alert("Creation of variable list failed.");
	   }
}

function findVar(line) {
   //all variable assigments are separated with " = " courtesy of the way the MOO outputs code text for display;
   var counter=0;
   var lineItems=line.split(" ");
   var varItems= new Array();
   for (var i=0; i<lineItems.length; i++) {
          if (lineItems[i]==="="){
	      var found=lineItems[i-1];
		  // check if found variable should be excluded;
		  if(checkForExcludedValue(found)){
		     varItems[counter]=lineItems[i-1];
		     counter=counter+1;
             }
	  } 
	}  
	  if (counter){  
         return varItems;
	  }
      else {
	     return false;
	  }
}
	  
function checkForExcludedValue(found) {
   //exclude potential variables if they start with any thing in the following array;
   //these are commented out lines, arg strings etc; 
   //we will figure out what to do with arg assignments someday;
   var initPatterns=['"',"?","{","(",")"];
   var finalPatterns=["}",")"];
   var firstChar=found[0];
   var lastChar=found[found.length-1];
   for(var c=0; c<initPatterns.length; c++){
      if(firstChar===initPatterns[c]){
	 	  return false
	  }
	}
   for(var d=0; d<finalPatterns.length; d++) {	
	  if(lastChar===finalPatterns[d]){
	 	  return false
	  }
   } 
	  return true;
}

function createChkboxList(varList) {
   var chkboxDiv=document.getElementById("varChkBoxes");
   var list="";
   for(var e=0;e<varList.length;e++) {
       var checkbox = "<input type='checkbox' name='variables' id='"+varList[e]+"' value='"+varList[e]+"' />"+varList[e]+"<br />";
	   list=list+checkbox;
   }
   chkboxDiv.innerHTML=list;
return true;
}

function createCheckPoint() {
   formArray=document.getElementById('checkPointData').variables;
   var checkPointTxt='$bp:cp('+document.getElementById('player').value+','+document.getElementById('object').value;
   checkPointTxt=checkPointTxt+',"'+document.getElementById('verb').value+'","'+document.getElementById('txtString').value+'"';
   var checkPointItems=",{";
   var varRec;
   var numChecked=0;
   var checkCount=0;
   //count number of checked variables;
   for(var c=0;c<formArray.length;c++) { 
    if (formArray[c].checked){
	    numChecked=numChecked+1; 
	    }
	}		
   for(var c=0;c<formArray.length;c++) {
      //alert(formArray[c].value);
      if (formArray[c].checked){
	     checkCount=checkCount+1;
	     if(numChecked===1 || checkCount===numChecked) {
		 varRec='{"'+formArray[c].value+'",'+formArray[c].id+'}';
         checkPointItems=checkPointItems+varRec;
		 }
         else {
         varRec='{"'+formArray[c].value+'",'+formArray[c].id+'},';
         checkPointItems=checkPointItems+varRec;		
	     }
        }
	}
   checkPointTxt=checkPointTxt+checkPointItems+"});";
   parent.frames["editor"].editAreaLoader.setSelectedText('verb_code',checkPointTxt);
   parent.view3.location.href = '/Xpress_Program_Editor/debug_notify?Checkpoint added.';
}
//Breakpoints are essentially the same as Checkpoints except that they stop the verb from executing.
function createBreakPoint() {
   formArray=document.getElementById('checkPointData').variables;
   var checkPointTxt='$bp:bp('+document.getElementById('player').value+','+document.getElementById('object').value;
   checkPointTxt=checkPointTxt+',"'+document.getElementById('verb').value+'",task_id(),"'+document.getElementById('txtString').value+'"';
   var checkPointItems=",{";
   var varRec;
   var numChecked=0;
   var checkCount=0;
   //count number of checked variables;
   for(var c=0;c<formArray.length;c++) { 
    if (formArray[c].checked){
	    numChecked=numChecked+1; 
	    }
	}		
   for(var c=0;c<formArray.length;c++) {
      //alert(formArray[c].value);
      if (formArray[c].checked){
	     checkCount=checkCount+1;
	     if(numChecked===1 || checkCount===numChecked) {
		 varRec='{"'+formArray[c].value+'",'+formArray[c].id+'}';
         checkPointItems=checkPointItems+varRec;
		 }
         else {
         varRec='{"'+formArray[c].value+'",'+formArray[c].id+'},';
         checkPointItems=checkPointItems+varRec;		
	     }
        }
	}
   checkPointTxt=checkPointTxt+checkPointItems+"});suspend();";
   parent.frames["editor"].editAreaLoader.setSelectedText('verb_code',checkPointTxt);
   parent.view3.location.href = '/Xpress_Program_Editor/debug_notify?Breakpoint added.';
}
function clearAllCheckPoints() {
   if (confirm(' Are you sure you want to remove all the check and breakpoints?')) {
      var tmpString=String();
	  var stuff=parent.frames["editor"].editAreaLoader.getValue("verb_code");
	  var allLines = stuff.split("\n") //split using LF;
      //alert("code has "+ allLines.length +" lines.");
	  for (var i=0; i<allLines.length;) {
	  tmpString=allLines[i];  
	  //alert(tmpString);
	  if(tmpString.match("bp:cp")) {
	            //alert("found checkpoint at line: "+(i+1));
                allLines.splice(i, 1);
			} else if (tmpString.match("bp:bp")) {
                //alert("found breakpoint at line: "+(i+1));
                allLines.splice(i, 1);
			} else if (tmpString.match("suspend")) {
                //alert("found orphan suspend at line: "+(i+1));
                allLines.splice(i, 1);	
			} else {
                i++;
            }
		  }
	  var newCode=allLines.join("\n");	
	  parent.frames["editor"].editAreaLoader.setValue("verb_code", newCode);
	  //alert("code now has "+allLines.length+" lines.");
	  parent.view3.location.href = '/Xpress_Program_Editor/debug_notify?All Check and Breakpoints cleared.';
      return true;
   }
   return false;
 }  